*     yo.f

      Program yo

************************************************************************
 5000 Format(/
     ,'Yo --- substitute words that definitely contain Russian letter' /
     /'       yo by reading and indexing the yo dictionary and use' /
     /'       dichotomic searching in the first letter range.' /
     /'       The dictionary is a text file based on the list gifted' /
     /'       by Michael Panov.' //
     /'Version ',f4.2,'. Last update: 18/09/2018' //
     /'Compiled with GNU Fortran.' //
     /'(C) 2003--2018 Michael Golub * E-mail: mike-golub@yandex.ru' / )
************************************************************************

      Real              ver / 1.65 /

      Integer           MaxWords, nwords, nidx, io, na, lastarg, lncnt
      Parameter        (MaxWords=65536)
      Character *    30 YoWords(MaxWords), buff
      Integer   *     4 YoLen(MaxWords), maxlen, minlen
*     Integer   *     2 YoLen(MaxWords), maxlen, minlen
      Character *     1 FirstChar, PrevChar, ch, tab ! / 9 /
      Character *   255 target
      Character *   765 targetl
      Integer           idx(34), hash(36), nh, i, j, k, ifound
      Integer           hits, lhits
      Character *   255 InFile, OutFile, LogFile, path
      Character *     6 dic / 'yo.dic' /
*     Integer   *     2 infln,  outfln, logfln, pathln
      Integer   *     4 infln,  outfln, logfln, pathln
*     Integer   *     2 dos, win, koi, utf
      Integer   *     4 dos, win, koi, utf
      Parameter        (dos=1, win=2, koi=3, utf=4)
*     Integer   *     2 coding(3) / win, win, utf /, native / win /
*     Integer   *     4 coding(3) / win, win, win /, native / win /
      Integer   *     4 coding(3) / win, win, utf /, native / win /
      Integer           Search, iFindExt, np, llen, ws, we, lnt, lntl
      Integer           lnl, ltl
      Character * 1048576 line
      Character * 3145728 linel
      Logical   *     1 inword, wordbeg, wordend, eflag, nquiet /.true./
      Character *    66 rus
      Real              timer, timerd
      Logical   *     1 wascr, eqbs, bsflag, wasbs, lastchar
      Logical   *     1 thflag, ehflag

      Common / CRLF / wascr
      Common / yodic / YoWords, YoLen, nwords, hash, idx, nidx

************************************************************************
      tab=Char(9)

      Print 5000, ver

      timer=Secnds(0.)

      ! Extract program file path
      ! Call GetArg(0, path); pathln=Len_Trim(path)
      Call Get_command_argument(0, path, pathln, io)
      If (io/=0) Then
         Print *, 'Too long path to the program. Sorry.'; Call Exit(12)
      End If

      If (Index(path(1:pathln), '/')==0) Then
         Print *, 'The program started from the shell that hides paths,'
         Print *, 'so cannot locate its dictionary file., Sorry.'
         Call Exit(13)
      End If

      ! print *, 'trimmed path=',path(1:pathln)

      Do i=pathln, 1, -1
         If (path(i:i)/='/') Cycle; pathln=i; Exit
      End Do

      ! print *, 'stripped path=',path(1:pathln)

      na=iArgc(); If (na<1) Call Help

      lastarg=0

      ! Looking for options
      Do i=1, na
         Call GetArg(i, InFile); infln=Len_Trim(InFile)
         If (InFile(1:1)/='-') Then; lastarg=i; Exit; End If
         ! option
         Do j=2, infln
            FirstChar=InFile(j:j)
*           If (Index('hHdDwWkKqQuU1234', FirstChar)==0) Then
            If (Index('hHdDwWkKqQ1234', FirstChar)==0) Then
               Print *, 'Invalid key "', FirstChar, '".'; Call Exit(11)
            End If
            If (FirstChar=='h' .or. FirstChar=='H') Call Help
            If (FirstChar=='d') coding(1)=dos
            If (FirstChar=='D') coding(2)=dos
            If (FirstChar=='1') coding(3)=dos
            If (FirstChar=='w') coding(1)=win
            If (FirstChar=='W') coding(2)=win
            If (FirstChar=='2') coding(3)=win
            If (FirstChar=='k') coding(1)=koi
            If (FirstChar=='K') coding(2)=koi
            If (FirstChar=='3') coding(3)=koi
*           If (FirstChar=='u') coding(1)=utf
*           If (FirstChar=='U') coding(2)=utf
            If (FirstChar=='4') coding(3)=utf
            nquiet=(FirstChar/='q' .and. FirstChar/='Q')
         End Do
      End Do

      If (lastarg==0) Then
         Print *, 'No InFile mask specified. Run yo -h for help.'
         Call Exit(12)
      End If

      nwords=0; nidx=0; PrevChar=' '; maxlen=0; minlen=30

      ! ANSI (windows cp-1251) coding
      rus(1:33) ='_' ! lower
      rus(32:32)=Char(255) ! avoid problems with explicit char 255
      rus(34:66)='ߨ' ! upper

      Do i=1, 36; hash(i)=0; End Do

      Open(1, File=path(1:pathln)//dic, Err=9001, Status='Old')

      Print *, 'Reading dictionary "', path(1:pathln)//dic, '"...'

      Do ! While(.true.)
         Call ReadLine(buff, llen, io)
         If (io<0) Exit
         If (io/=0) Go to 2001
         If (llen==0) Cycle ! blank line
         ! Convert to internal coding
         If (coding(2)/=native)
     ,      Call Translate(buff, llen, coding(2), native)
         nwords=nwords+1
         If (nwords>MaxWords) Then
            Print *, 'Too many words in the dictionary [>',MaxWords,'].'
            Close(1, IOStat=io); Call Exit(4)
         End If
         YoWords(nwords)=buff
         YoLen(nwords)=llen
         maxlen=Max(maxlen, llen)
         minlen=Min(minlen, llen)
         FirstChar=buff(1:1)
         If (FirstChar=='') FirstChar='' ! consider ==
         If (FirstChar/=PrevChar) Then
            nidx=nidx+1
            idx(nidx)=nwords
            nh=Index(rus(1:33), FirstChar)
            If (nh==0) Then
               If (coding(3)/=native)
     ,            Call Translate(FirstChar, 1, native, coding(3))
               Print *, 'Invalid first character "', FirstChar, '" at ',
     ,                  'line #', nwords, '.'
               Close(1, IOstat=io)
               Call Exit(3)
            End If
            hash(nh)=nidx ! lowercase Russian
            PrevChar=FirstChar
         End If
      End Do

      Close(1, IOStat=io)
      nidx=nidx+1
      idx(nidx)=nwords+1

      timerd=Secnds(0.)

      Print *, nwords, ' entries of ', nidx,
     ,                 ' groups read in ', timerd-timer, ' sec.'

      Print *

************************************************************************

      hits=0

      Do i=lastarg, na ! argument getting loop

         lhits=0

         Call GetArg(i, InFile); infln=Max(1, Len_Trim(InFile))
         Open(1, File=InFile(1:infln), Err=8001)

         np=iFindExt(InFile, infln)

         If (np==0) Then
            outfln=Min(252, infln); logfln=Min(249, infln)
            OutFile=InFile(1:outfln)//'.yo'; outfln=outfln+3
            LogFile=InFile(1:logfln)//'.yolog'; logfln=logfln+6
         Else
            If (np==1) Then
               outfln=3; OutFile(1:3)='.yo'
               logfln=6; LogFile(1:6)='.yolog'
            Else
               outfln=Min(252, np-1); logfln=Min(249, np-1)
               OutFile=InFile(1:outfln)//'.yo'; outfln=outfln+3
               LogFile=InFile(1:logfln)//'.yolog'; logfln=logfln+6
            End If
         End If

         Open(2, File=OutFile(1:outfln), Err=8002)
         Open(3, File=LogFile(1:logfln), Err=8003)

         Print *, InFile(1:infln), ' ==> ', OutFile(1:outfln), '...'
         Write(3, 5000, Err=3003) ver
         Write(3, '(a," ==> ",a,"...")', Err=3003)
     ,         InFile(1:infln), OutFile(1:outfln)

         wascr=.false.; lncnt=0

         Do ! While(.true.) ! reading loop

            Call ReadLine(line, llen, io)
            If (io<0) Exit
            If (io/=0) Go to 2002

            lncnt=lncnt+1

            ! Blank line
            If (llen==0) Then; Write(2, *, Err=3002); Cycle; End If

            ! Convert to internal coding
            If (coding(1)/=native)
     ,         Call Translate(line, llen, coding(1), native)

            eflag=.false.
            wordbeg=.false.; wordend=.false.; inword=.false. ! word flags
            ws=0; we=0 ! word boundaries
            ifound=0; ! last backspace position
            wasbs=.false.; bsflag=.false.; thflag=.false.; eqbs=.false.

            Do j=1, llen ! Look for e-containing word in the line

               ch=line(j:j)

               thflag=(ch=='-' .and. bsflag) ! \- TeX hyphenation flag
               ehflag=(ch=='') ! explicit ANSI hyphenation flag
               eqbs=(ch=='\')
               lastchar=(j==llen)
               ! abcde=\-abcde=abcde\- abc\-de
               wasbs=bsflag
               bsflag=(eqbs .and. .not. bsflag) ! \ and not \\
               if (bsflag) ifound=j
               If (eqbs .and. bsflag .and. .not. lastchar) Cycle

               inword=(Index(rus, ch)>0 .or. thflag .or. ehflag)

               If (inword) Then
                  ! native (ANSI) `Ee' = KOI `eE'
                  eflag=eflag .or. (ch=='' .or. ch=='')
                  If (wordbeg) Then
                     If (.not. lastchar) Cycle
                  Else
                     If (thflag .or. ehflag ) Cycle ! ignore leading \-, 
                     ws=j; wordbeg=.true.
                  End If
                  If (.not. lastchar) Cycle
                  we=j; wordend=.true. ! end of line terminates the word
                  If (thflag) we=we-2 ! trailing \-
                  If (ehflag) we=we-1 ! trailing 
                  If (eqbs)   we=we-1 ! trailing \
                  if (wasbs)  we=ifound-1
               Else
                  If (.not. wordbeg) Cycle
                  wordend=.true.
                  we=j-1
                  If (thflag) Then; we=we-1 ! trailing \-
                              Else; If (wasbs) we=we-1 ! trailing \-
                              End If
                  ! ehflag=.true. check seems unnecessary here
               End If

               If (.not. wordend) Cycle

               wordbeg=.false.; wordend=.false.; wasbs=.false.

               ! Test commands starting with Russian
               ifound=ws
               Do ! While( .true. )
                  k=ifound ! previous offset
                  ifound=Index(line(k:we), '\')
                  If (ifound==0) Exit
                  ifound=k+ifound
                  If (Index(rus, line(ifound:ifound))>0) Exit
               End Do
               If (ifound==ws) Cycle ! \[Russian]
               If (ifound>0) we=ifound-2 ! [Russian1]\[Russian2] -> [Russian1]

               If (eflag) Then ! e exists in the word
                  eflag=.false.
                  lnt=we-ws+1
                  target(1:lnt)=line(ws:we)

                  ! Make lowercase pattern without \- or  if any ******
                  lntl=0
                  Do k=1, lnt
                     ch=target(k:k)
                     If (ch/='\' .and. ch/='-' .and. ch/='') Then
                         lntl=lntl+1; targetl(lntl:lntl)=ch
                     End If
                  End Do

                  Call Lowercase(targetl, lntl, rus)
                  !*****************************************************

                  ifound=Search(targetl, lntl, maxlen, minlen, rus)
                  If (ifound==0) Cycle

                  ! Copy found string if not the same
                  ! (the word may contain both `e' and 'yo', finding
                  ! `e' causes the search and no extra `yo' may be
                  ! needed, it's quite common)
                  If (targetl(1:lntl)==YoWords(ifound)(1:lntl)) Cycle
                  targetl(1:lntl)=YoWords(ifound)(1:lntl)

                  ! Copy capitalization from the original target
                  lntl=0
                  Do k=1, lnt
                     ch=target(k:k)
                     If (ch/='\' .and. ch/='-' .and. ch/='') Then
                        np=Index(rus(34:66), ch) ! uppercase
                        lntl=lntl+1
                        ch=targetl(lntl:lntl) ! next letter of targetl
                        If (np>0) Call Uppercase(ch, 1, rus) ! uppercase if required
                        target(k:k)=ch ! copy original or uppercased targetl letter
                     End If
                  End Do

                  targetl(1:lnt)=target(1:lnt)
                  linel(ws:we)=line(ws:we)

                  If (coding(2)/=native) Then
                     Call Translate(linel(ws:we),lnt,native,coding(2))
                     Call Translate(targetl,     lnt,native,coding(2))
                  End If

                  Write(3, *, Err=3003) '  line=', lncnt, tab,
     ,                        'col=', ws, ' --', we, ' ', tab,
     ,                        linel(ws:we), ' --> ', targetl(1:lnt)

                  If (nquiet) Then
                     targetl(1:lnt)=target(1:lnt)
                     linel(ws:we)=line(ws:we)

                     If (coding(3)==utf) Then
                        Call win2utf(line, ws, we, linel, lnl)
                        Call win2utf(target, 1, lnt, targetl, ltl)
                        Print *, '  line=', lncnt, tab,
     ,                        'col=', ws, ' --', we, ' ', tab,
     ,                        linel(1:lnl), ' --> ', targetl(1:ltl)
                     Else
                      If (coding(3)/=native) Then
                       Call Translate(linel(ws:we),lnt,native,coding(3))
                       Call Translate(targetl,     lnt,native,coding(3))
                      End If
                      Print *, '  line=', lncnt, tab,
     ,                        'col=', ws, ' --', we, ' ', tab,
     ,                        linel(ws:we), ' --> ', targetl(1:lnt)
                     End If

                  End If

                  line(ws:we)=target(1:lnt)
                  hits=hits+1; lhits=lhits+1

               End If

            End Do ! Look for e-containing word in the line

            ! Convert back from internal coding
            If (coding(1)/=native)
     ,         Call Translate(line, llen, native, coding(1))
            Write(2, "(a)", Err=3002) line(1:llen)

         End Do ! reading loop

         Write(3, *, Err=3003)
         Write(3, *, Err=3003) '  Hits: ', lhits
         Call CloseFiles(1, 3)
         If (nquiet) Then
            Print *
            Print *, '  Hits: ', lhits
            Print *
         End If

      End Do ! argument getting loop

      Print *, 'Conversion duration: ', Secnds(timerd), ' sec.'
      Print *, 'Total duration:      ', Secnds(timer), ' sec.'
      Print *, 'Total hits:          ', hits
      Print *, 'Done.'

      Stop
************************************************************************

 9001 Continue
         Print *, 'Error opening ', path(1:pathln), dic; Call Exit(1)

 2001 Continue
         Close(1, IOStat=io)
         Print *, 'Error reading ', path(1:pathln), dic; Call Exit(2)

 8001 Continue
         Print *, 'Error opening "',InFile(1:infln),'"'; Call Exit(5)

 8002 Continue
         Close(1, IOStat=io)
         Print *, 'Error opening "',OutFile(1:outfln),'"'; Call Exit(6)

 8003 Continue
         Call CloseFiles(1, 2)
         Print *, 'Error opening "',LogFile(1:logfln),'"'; Call Exit(9)

 2002 Continue
         Call CloseFiles(1, 3)
         Print *, 'Error reading "',InFile(1:infln),'"'; Call Exit(7)

 3002 Continue
         Call CloseFiles(1, 3)
         Print *, 'Error writing "',OutFile(1:outfln),'"'; Call Exit(8)

 3003 Continue
         Call CloseFiles(1, 3)
         Print *, 'Error writing "',LogFile(1:logfln),'"'; Call Exit(10)

      End

************************************************************************
      Subroutine CloseFiles(fna, fnb) ! quietly close files
************************************************************************
      Integer    fna, fnb, i, io

      Do i=fna, fnb; Close(i, IOStat=io); End Do

      Return
      End

************************************************************************
      Integer Function Search(target, lnt, maxlen, minlen, rus)
************************************************************************

      Integer         MaxWords
      Parameter      (MaxWords=65536)
      Character *  30 YoWords(MaxWords), worde
*     Integer   *   2 YoLen(MaxWords), maxlen, minlen
      Integer   *   4 YoLen(MaxWords), maxlen, minlen
      Character *   1 FirstChar
      Character * 255 target, targete
*     Integer         hash(36), nh, i, i1, i2, i3, nsteps
      Integer   *   4 hash(36), nh, i, i1, i2, i3, nsteps
*     Integer         idx(34), nidx, nwords, lnt, BoundaryCheck
      Integer   *   4 idx(34), nidx, nwords, lnt, BoundaryCheck
      Character *  66 rus

      Common / yodic / YoWords, YoLen, nwords, hash, idx, nidx

      Search=0 ! not found

      ! target is too long or too short
      If (lnt>maxlen .or. lnt<minlen) Return

      FirstChar=target(1:1)

      nh=Index(rus(1:33), FirstChar); If (nh==0) Return ! Not Russian lowercase

      nh=hash(nh); If (nh==0) Return ! No words starting with FirstChar

      i1=idx(nh); i2=idx(nh+1)-1 ! FirstLetter range
      nsteps=Int(1.5+log(i2-i1+1.)/log(2.)) ! dichotomy steps

      Call yo2e(target, lnt, targete)

      Search=BoundaryCheck(targete, lnt, i1, i2); If (Search>0) Return

      ! Dichotomy search
      Do i=1, nsteps
         If ((i1+1)==i2) Then ! unable to find i3 between i1 and i2
            Search=BoundaryCheck(targete, lnt, i1, i2); Return
         End If
         i3=(i1+i2)/2
         Call yo2e(YoWords(i3), Int(YoLen(i3)), worde)
         If (targete(1:lnt)==worde(1:YoLen(i3))) Then
            Search=i3; Exit
         End If
         If (targete(1:lnt)>worde(1:YoLen(i3))) Then; i1=i3
                                                Else; i2=i3; End If
      End Do

      Return
      End

************************************************************************
      Integer Function BoundaryCheck(targete, lnt, i1, i2)
************************************************************************

      Integer         MaxWords, lnt
      Parameter      (MaxWords=65536)
      Character *  30 YoWords(MaxWords), worde
*     Integer   *   2 YoLen(MaxWords)
      Integer   *   4 YoLen(MaxWords)
      Character * 255 targete
      Integer         hash(36), i1, i2, idx(34), nidx, nwords

      Common / yodic / YoWords, YoLen, nwords, hash, idx, nidx

      BoundaryCheck=0 ! not found

      ! Compare with range boundary words

      Call yo2e(YoWords(i1), Int(YoLen(i1)), worde)

           If (targete(1:lnt)<worde(1:YoLen(i1))) Return ! Not in the list
           If (targete(1:lnt)==worde(1:YoLen(i1))) Then
              BoundaryCheck=i1; Return
           End If

      Call yo2e(YoWords(i2), Int(YoLen(i2)), worde)

           If (targete(1:lnt)>worde(1:YoLen(i2))) Return ! Not in the list
           If (targete(1:lnt)==worde(1:YoLen(i2))) Then
              BoundaryCheck=i2; Return
           End If

      Return
      End

************************************************************************
      Subroutine yo2e(str, ln, stre) ! discard possible yo
************************************************************************

      Integer         ln, i
      Character * (*) str, stre

      Do i=1, ln
         stre(i:i)=str(i:i); If (stre(i:i)=='') stre(i:i)=''
      End Do

      Return
      End

************************************************************************
      Integer * 4 Function iFindExt(str, ln)
************************************************************************

      Character * 255 str
      Integer   *   4 ln, i
*     Integer   *   2 ln, i

      iFindExt=0

      Do i=ln, 1, -1 ! trace backward
         If (str(i:i)=='.') Then; iFindExt=i; Return; End If
      End Do

      Return
      End

************************************************************************
      Subroutine Lowercase(str, ln, rus)
************************************************************************

      Integer         ln, i, ch
      Character * (*) str
      Character *  66 rus

      Do i=1, ln
         ch=Index(rus(34:66), str(i:i)); If (ch==0) Cycle
         str(i:i)=rus(ch:ch)
      End Do

      Return
      End
************************************************************************
      Subroutine Uppercase(str, ln, rus)
************************************************************************

      Integer         ln, i, ch
      Character * (*) str
      Character *  66 rus

      Do i=1, ln
         ch=Index(rus(1:33), str(i:i)); If (ch==0) Cycle
         ch=ch+33
         str(i:i)=rus(ch:ch)
      End Do

      Return
      End

************************************************************************
      Subroutine ReadLine(str, ln, io)
************************************************************************
      Integer         lstr, i, ln, io, EOF / -1 /
*     Character *  1  buffer, CR / 13 / , LF / 10 /
      Character *  1  buffer, CR, LF
      Character * (*) str
      Logical   *  1  wascr

      Common / CRLF / wascr

      CR=Char(13); LF=Char(10)
      lstr=Len(str)

    1 Continue

      io=0
      ln=0

      Do i=1, lstr
         Call FGetC(1, buffer, io)
         If (io==EOF) Return
         If (io/=0  ) Return
         If (buffer==CR) Then; wascr=.true.; ln=i-1; Return; End If
         If (buffer==LF) Then
            If (wascr) Then; wascr=.false.; Go to 1; End If ! restart
            ln=i-1
            Return
         End If
         str(i:i)=buffer
      End Do

      Return
      End

************************************************************************
      Subroutine Translate(str, ln, in, out)
************************************************************************

*     Integer   *  2  ch, in, out
      Integer   *  4  ch, in, out
      Integer         i, ln
      Character * (*) str

      Integer * 2 dos(79), dosidx(128)
      Integer * 2 win(79), winidx(128)
      Integer * 2 koi(79), koiidx(128)

*    `'

      Data dos / 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
     ,17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,
     ,33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,
     ,97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110,
     ,111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123,
     ,125, 126, 127, 128 /
      !-- 

      Data win / 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78,
     ,79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94,
     ,95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108,
     ,109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
     ,122, 123, 124, 125, 126, 127, 128, 41, 57, 43, 59, 48, 64, 34, 35,
     ,49, 22, 56, 58, 37, 39, 33 /
                  !-- 

      Data koi / 98, 99, 120, 104, 101, 102, 119, 123, 106, 107, 108,
     ,109, 110, 111, 112, 113, 115, 116, 117, 118, 103, 105, 100, 127,
     ,124, 126, 128, 122, 121, 125, 97, 114, 66, 67, 88, 72, 69, 70, 87,
     ,91, 74, 75, 76, 77, 78, 79, 80, 81, 83, 84, 85, 86, 71, 73, 68,
     ,95, 92, 94, 96, 90, 89, 93, 65, 82, 52, 36, 26, 25, 20, 28, 32,
     ,24, 29, 22, 31, 64, 30, 21, 27 /
                      !-- 

      Data dosidx / 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
     ,16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
     ,32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
     ,48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     ,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     ,0, 0, 0, 0, 0, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
     ,62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 0, 76, 77,
     ,78, 79 /

      Data winidx / 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     ,0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 71, 72, 0, 77,
     ,0, 78, 0, 65, 0, 67, 0, 0, 0, 0, 69, 73, 0, 0, 0, 0, 0, 0, 75, 66,
     ,76, 68, 0, 0, 0, 0, 70, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13,
     ,14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
     ,30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45,
     ,46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
     ,62, 63, 64 /

      Data koiidx / 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     ,0, 0, 69, 78, 74, 0, 72, 68, 67, 79, 70, 73, 77, 75, 71, 0, 0, 0,
     ,66, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0,
     ,0, 0, 0, 0, 0, 0, 0, 76, 63, 33, 34, 55, 37, 38, 53, 36, 54, 41,
     ,42, 43, 44, 45, 46, 47, 48, 64, 49, 50, 51, 52, 39, 35, 61, 60,
     ,40, 57, 62, 58, 56, 59, 31, 1, 2, 23, 5, 6, 21, 4, 22, 9, 10, 11,
     ,12, 13, 14, 15, 16, 32, 17, 18, 19, 20, 7, 3, 29, 28, 8, 25, 30,
     ,26, 24, 27 /

      Do i=1, ln
         ch=iChar(str(i:i))-127
         If (ch<1) Cycle
         If (in==1) ch=dosidx(ch)
         If (in==2) ch=winidx(ch)
         If (in==3) ch=koiidx(ch)
         If (ch==0) Cycle
         If (out==1) ch=dos(ch)
         If (out==2) ch=win(ch)
         If (out==3) ch=koi(ch)
         str(i:i)=Char(ch+127)
      End Do

      Return
      End

************************************************************************
      Subroutine win2utf(line, i1, i2, linel, ln) ! convert ANSI to UTF8
************************************************************************

      Integer           i1, i2, ln, i, ch, cc
      Integer           B /194/, P /208/, C /209/, T /210/, V /226/
      Integer           pref1, pref2
      Character * (*)   line
      Character * (*)   linel

      pref1=0
      pref2=0
      ln=0
      Do i=i1, i2
         ch=iChar(line(i:i))
         cc=-1
         pref1=0
         Select Case (ch)
              Case (128:129);          pref2=P;   cc=ch+2
              Case (130);     pref1=V; pref2=128; cc=154
              Case (131);              pref2=C;   cc=147
              Case (132);     pref1=V; pref2=128; cc=158
              Case (133);     pref1=V; pref2=128; cc=166
              Case (134:135); pref1=V; pref2=128; cc=ch+26
              Case (136);     pref1=V; pref2=130; cc=172
              Case (137);     pref1=V; pref2=128; cc=176
              Case (138);              pref2=P;   cc=137
              Case (139);     pref1=V; pref2=128; cc=185
              Case (140);              pref2=P;   cc=138
              Case (141);              pref2=P;   cc=140
              Case (142);              pref2=P;   cc=139
              Case (143);              pref2=P;   cc=143
              Case (144);              pref2=C;   cc=146
              Case (145);     pref1=V; pref2=128; cc=152
              Case (146);     pref1=V; pref2=128; cc=153
              Case (147);     pref1=V; pref2=128; cc=156
              Case (148);     pref1=V; pref2=128; cc=157
              Case (149);     pref1=V; pref2=128; cc=162
              Case (150);     pref1=V; pref2=128; cc=147
              Case (151);     pref1=V; pref2=128; cc=148
              Case (152);              pref2=B;   cc=152
              Case (153);     pref1=V; pref2=132; cc=162
              Case (154);              pref2=C;   cc=153
              Case (155);     pref1=V; pref2=128; cc=186
              Case (156);              pref2=C;   cc=154
              Case (157);              pref2=C;   cc=156
              Case (158);              pref2=C;   cc=155
              Case (159:160);          pref2=C;   cc=ch
              Case (161);              pref2=P;   cc=142
              Case (162);              pref2=C;   cc=158
              Case (163);              pref2=P;   cc=136
              Case (164);              pref2=B;   cc=164
              Case (165);              pref2=T;   cc=144
              Case (166);              pref2=B;   cc=166
              Case (167);              pref2=B;   cc=167
              Case (168);              pref2=P;   cc=129 ! Yo
              Case (169);              pref2=B;   cc=169
              Case (170);              pref2=P;   cc=132
              Case (171:174);          pref2=B;   cc=ch
              Case (175);              pref2=P;   cc=135
              Case (176:177);          pref2=B;   cc=ch
              Case (178);              pref2=P;   cc=134
              Case (179);              pref2=C;   cc=150
              Case (180);              pref2=T;   cc=145
              Case (181:183);          pref2=B;   cc=ch
              Case (184);              pref2=C;   cc=145 ! yo
              Case (185);     pref1=V; pref2=132; cc=150 ! No
              Case (186);              pref2=C;   cc=148
              Case (187);              pref2=B;   cc=ch
              Case (188);              pref2=C;   cc=152
              Case (189);              pref2=P;   cc=133
              Case (190);              pref2=C;   cc=149
              Case (191);              pref2=C;   cc=151
              Case (192:239);          pref2=P;   cc=ch-48 ! A-Ya+a-p
              Case (240:255);          pref2=C;   cc=ch-112 ! r-ya
              ! Case Default
         End Select
         If (cc>0) Then
            If (pref1/=0) Then
               ln=ln+1; linel(ln:ln)=Char(pref1)
            End If
            ln=ln+1; linel(ln:ln)=Char(pref2)
         Else
            cc=ch
         End If
         ln=ln+1; linel(ln:ln)=Char(cc)
      End Do

      Return
      End

************************************************************************
      SubRoutine Help
************************************************************************

      Print 6000
 6000 Format(/'Correct form is: yo [[keys] InFileMask]'/
     /'Keys are as follows:'/
     /'     -h, -H = display this help (same as no arguments);'/
     /'     -d = DOS (ASCII, IBM alternatively) coded file;'/
     /'     -w = Windows (ANSI) coded file;'/
     /'     -k = KOI8-R coded file;'/
     /'     -D = DOS coded dictionary;'/
     /'     -W = Windows coded dictionary;'/
     /'     -K = KOI8-R coded dictionary;'//
     /'     -1 = DOS coded terminal;'/
     /'     -2 = Windows coded terminal (default);'/
     /'     -3 = KOI8-R coded terminal;'/
     /'     -4 = UTF8 coded terminal;'/
     /'     -q, -Q = quiet: diminish verbosity.'//
     /'When used together keys may be combined, e.g., -dW2.'/
     /'*Note*: modern Cygwin''s terminal is ANSI. Specify another one '/
     /'if you cannot see correct Russian letters.'/
     /'If keys conflict the last one is in effect.'/
     /'InFileMask is the correct file mask for your OS (e.g., *.txt).'/
     /'OutFile is formed as fname.yo, fname is the name of InFile.'/
     /'LogFile is formed as fname.yolog, fname is the name of InFile.'/
     /'Dash by itself does nothing.'//
     /'The program reads lines up to 1048576 bytes long, the rest is'/
     /'silently ignored.'//)

      Call Exit(10)

      End

